Public Member Functions

# BinNavi.API.debug.Memory Class Reference

Simulates the memory of a target process. More...

List of all members.

## Public Member Functions
void | addListener (final IMemoryListener listener)
| Adds memory listeners.
byte[] | getData (final long start, final int length) throws MissingDataException
| Reads data from memory.
boolean | hasData (final long start, final int length)
| Checks for the existence of data in the memory.
void | removeListener (final IMemoryListener listener)
| Removes memory listeners.
String | toString ()
| Printable representation of the memory.

## Detailed Description

Simulates the memory of the target process. The simulated memory of the target process contains all the data that was already sent from the debug client to BinNavi.

## Member Function Documentation

void BinNavi.API.debug.Memory.addListener | ( | final IMemoryListener | listener | ) |

Adds an object that is notified about changes in the simulated memory.

Parameters:

  | listener | The listener object that is notified about changes in the simulated memory.

Exceptions:

  | IllegalArgumentException | Thrown if the listener argument is null.
  | IllegalStateException | Thrown if the listener object is already listening on the simulated memory.

byte [] BinNavi.API.debug.Memory.getData | ( | final long | start,
|  | final int | length |
| ) |  |  | throws MissingDataException

Returns the data of a given memory section of the simulated memory.

Parameters:

  | start | The start of the memory section.
  | length | Number of bytes in the memory section.

Returns:
  Byte-array that contains the bytes of the target process memory.

Exceptions:

  | MissingDataException | Thrown if the requested memory data is not available.

boolean BinNavi.API.debug.Memory.hasData | ( | final long | start,
|  | final int | length |
| ) |  |  |

Determines whether a given memory section is available in the simulated memory.

Parameters:

  | start | The start of the memory section.
  | length | Number of bytes in the memory section.

Returns:
  True, if the memory section is available in the simulated memory. False, if it is not.

void BinNavi.API.debug.Memory.removeListener | ( | final IMemoryListener | listener | ) |

Removes a listener object from the database.

Parameters:

  | listener | The listener object to remove from the database.

Exceptions:

  | IllegalArgumentException | Thrown if the listener argument is null.
  | IllegalStateException | Thrown if the listener object was not listening on the database.

String BinNavi.API.debug.Memory.toString | ( |  | ) |

Returns a string representation of the memory object.

Returns:
  A string representation of the memory object.